package jp.co.ulsystems.tools.taglets;

import java.util.Map;

import com.sun.javadoc.Tag;
import com.sun.tools.doclets.Taglet;

public class SpecTaglet implements Taglet {

    public String getName() {
        return "spec";
    }

    public boolean inField() {
        return true;
    }

    public boolean inConstructor() {
        return true;
    }

    public boolean inMethod() {
        return true;
    }

    public boolean inOverview() {
        return true;
    }

    public boolean inPackage() {
        return true;
    }

    public boolean inType() {
        return true;
    }

    public boolean isInlineTag() {
        return false;
    }

    public static void register(Map tagletMap) {
        SpecTaglet taglet  = new SpecTaglet();
        Taglet t = (Taglet) tagletMap.get(taglet.getName());
        if (t != null) {
            tagletMap.remove(taglet.getName());
        }
        tagletMap.put(taglet.getName(), taglet);
    }

    public String toString(Tag tag) {
        return new StringBuffer("<dt><b>dl&nbsp;:</b></dt><dd>").append(getLinkText(tag)).append("</dd>").toString();
    }

    public String toString(Tag[] tags) {
        if (tags.length == 0) {
            return null;
        }
        StringBuffer result = new StringBuffer("<dt><b>dl&nbsp;:</b></dt><dd>");
        for (int i = 0; i < tags.length; i++) {
            if (i > 0) {
                result.append(", ");
            }
            result.append(getLinkText(tags[i]));
        }
        return result.append("</dd>").toString();
    }

    protected StringBuffer getLinkText (Tag tag) {
    	return new StringBuffer("<a href='file:///c:\\spec\\").append(tag.text()).append("' target='_blank'>").append(tag.text()).append("</a>");
    }
}
